Subject: Re: Bug#657390: lintian: Please make build-arch and build-indep required targets

From: Roger Leigh <[email-masked]>
Date: Tue, 22 Jan 2013 23:16:06 +0000

On Thu, Jan 10, 2013 at 11:46:46AM +0100, Niels Thykier wrote:
> On 2012-02-08 13:23, Niels Thykier wrote:
> > On 2012-01-25 23:18, Roger Leigh wrote:
> >[...]
> >> Once build-arch and build-indep are supported by dpkg-buildpackage,
> >> hopefully in the next week, and/or are required by Policy, please
> >> could you apply the attached patch to move build-arch and build-indep
> >> from recommended to required?
> 
> Things have changed a bit since we talked about this last year.
> 
> This number is now about 3700, which is still a bit much.  In the
> interest of not getting a lot of mail from people aggrevated by their
> package being auto-rejected, I still feel the tags should remain split
> for now (until that number drops a bit more and Wheezy has been released).
> 
> I am open to bumping the severity of the recommended-target tag
> (possibly including a rename) to make the tag more visible and hopefully
> increasing the adoption rate of this tag (well, the post-freeze adoption
> rate).

Ccing the dpkg maintainers, since the lintian checks will be
coupled to changes in the tools, and it's really down to them
when this happens.

When we discussed introduction of the targets, my understanding
what that we agreed to use auto-detection of the build-arch and
build-indep targets on a strictly temporary basis to allow a
migration to having them be optional but recommended for wheezy,
and that for jessie we would be removing the autodetection logic
(or at least having it not be the default) and making them a hard
requirement.

I still see this as being the goal we want to achieve, and given
that the autodetection is a horrible hack, I think removal for
jessie is still needed, and our tools can then start to rely on
these targets being present.

From the POV of lintian, I think that we would want to encourage
adoption as quickly as possible post-wheezy in order that
dpkg-buildpackage can remove the autodetection by default.  Would
it be possible to make this a "required" check, perhaps with an
exception for being auto-rejected to begin with?  If we can
agree on a timeframe for migration, perhaps with a hard deadline
when the change will be made, this would spur more complete
adoption before packages start being rejected and maintainers
are forced to use the targets.  Of course, we don't yet know
when wheezy will release, but it would be good to have some
sort of tentative plan in place for doing this.  We wouldn't
need to turn off autodetection until later into the jessie
development cycle, but probably would be best to have done
well before the freeze to allow the remaining packages to be
fixed, so that would give maintainers a good year(?) to fix
their stuff on top of the 1.5+ years they will have had since
autodetection was introduced.

That's my thoughts anyway, any other suggestions welcome!

Kind regards,
Roger

-- 
  .''`.  Roger Leigh
 : :' :  Debian GNU/Linux    http://people.debian.org/~rleigh/
 `. `'   schroot and sbuild  http://alioth.debian.org/projects/buildd-tools
   `-    GPG Public Key      F33D 281D 470A B443 6756 147C 07B3 C8BC 4083 E800